
#define NUMBER_OF_DEFAULT_VAL           0x0e

#define I2C_ZOOM_IN                    0x01
#define I2C_ZOOM_OUT                   0x02
#define I2C_ZOOM_STOP                  0x03
#define I2C_ZOOM_MODE_NORM             0x04
#define I2C_ZOOM_MODE_DIG_OFF          0x05
#define I2C_ZOOM_MODE_ZOOM_2_POS       0x06
#define I2C_ZOOM_POSITION_H            0x07
#define I2C_ZOOM_POSITION_L            0x08

#define I2C_FOCUS_AUTO                 0x10
#define I2C_FOCUS_ON_ZOOM              0x11
#define I2C_FOCUS_TELE                 0x12
#define I2C_FOCUS_WIDE                 0x13
#define I2C_FOCUS_STOP                 0x14
#define I2C_FOCUS_MAN                  0x15

#define I2C_AWB_AUTO                    0x20
#define AWM_MANUAL_MODE                 0x21
#define I2C_AWB_P2S                     0x22
#define I2C_WB_RGAIN                    0x23
#define I2C_WB_BGAIN                    0x24
#define I2C_PSW_ACT                     0x25

#define I2C_AEX_MODE                    0x30
#define AEX_GAIN_MANUAL                 0x01                // flags to indicate which aex function is manual
#define AEX_SHUTTER_MANUAL              0x02
#define AEX_IRIS_MANUAL                 0x04
#define AEX_AUTO_GAIN                   0x35
#define I2C_DAY_NIGTH_MODE              0x36
#define APERATURE_GAIN                  0x3b
#define FLICKER_LESS_SHUTTER            0xff

#define WDR_MODE_OFF                    0x0
#define WDR_MODE_ON                     0x80
#define DNR_MODE_ON                     0x80
#define DNR_MODE_OFF                    0x00

#define I2C_MIRROR_MODE                 0x51
#define I2C_FLIP_MODE                   0x52
#define I2C_FREEZE_MODE                 0x53
#define I2C_IMAGE_STABALIZER            0x54
#define I2C_VIDEO_MODE                  0x55
#define I2C_IMAGE_STABALIZER_LEVEL      0x56
#define I2C_IMAGE_STABALIZER_Range      0x57


// define error messages:
#define SUCCESS                         0x00
#define I2C_ERROR                       0x01
#define I2C_NO_RESPONSE_CAMERA          0x02
#define I2C_ERROR_FAILED_TO_OPEN_BUS    0x80
#define I2C_ERROR_FAILED_CONTACT_DEVICE 0x81
#define I2C_ERROR_FAILED_WRITING        0x82
#define I2C_ERROR_FAILED_READING        0x83
#define I2C_WRONG_COMMAND               0xfe
#define ERROR_UNKOWN                    0xff

#define DEFAULT_ZOOM_POS                0x00
#define DEFAULT_ZOOM_SPEED              0x03
#define DEFAULT_FOCUS_SPEED             0x03
#define DEFAULT_MANUAL_GAIN             0x20
#define DEFAULT_MANUAL_SHUTTER          0x00
#define DEFAULT_MANUAL_IRIS             0x20
#define DEFAULT_WDR_LEVEL               0x01
#define DEFAULT_DNR_LEVEL               0x01
#define DEFAULT_MANUAL_REDGAIN          0x40
#define DEFAULT_MANUAL_BLUEGAIN         0x40
#define DEFAULT_IM_STABILIZER           0x2
#define DEFAULT_IM_STABILIZER_FILTER    0x02
#define DEFAULT_APERATURE_GAIN          0x02
#define DEFAULT_VIDEO_MODE              0x03                //60Hz 1080P

#define CAMERA_DEV_ADDRES               0x1e                            // = 7 bit vallue 0x36--> 8 bit = 0x6c
#define CAMERA_DEV_ADDRES_WRITE         (CAMERA_DEV_ADDRES * 2)
#define CAMERA_DEV_ADDRES_READ          ((CAMERA_DEV_ADDRES * 2) + 1)

typedef unsigned char  uint8_t;

uint8_t LoadDefaultValuesAtStartUp(uint8_t *pArrayCamVal);


uint8_t I2C_Zoom_Fuction( uint8_t zoomCommand, uint8_t zoomSpeed, uint8_t *zoomData);
uint8_t I2C_Focus_Fuction( uint8_t focusCommand, uint8_t focusSpeed, uint8_t *focusData);
uint8_t I2C_AWB_Fuction( uint8_t awbCommand, uint8_t *awbData);
uint8_t I2C_AEX_Fuction( uint8_t aexCommand, uint8_t *aexData);
uint8_t I2C_WDR_Fuction( uint8_t wdrCommand, uint8_t wdrLevel);
uint8_t I2C_DNR_Fuction( uint8_t dnrCommand, uint8_t dnrLevel);
uint8_t I2C_Feature_Fuction( uint8_t featureCommand, uint8_t *pData);


uint8_t OpenI2CBus(void);
uint8_t WriteI2CData(uint8_t *pRegaddress, uint8_t *pDataBuffer, uint8_t sizeReginBytes, uint8_t sizeDatainBytes);
uint8_t ReadI2CData(uint8_t *pRegaddress, uint8_t *pDataBuffer, uint8_t sizeReginBytes, uint8_t sizeDatainBytes);
