#include <iostream>
#include <opencv2/opencv.hpp>
#include <opencv2/highgui.hpp>

#include <opencv2/core.hpp>
#include <opencv2/videoio/videoio_c.h>

#include "ImageViewer.h"


using namespace cv;
using namespace std;


int CVid::StartImageViewer(void)
{
Mat frame;
VideoCapture cap(0);
if(!cap.isOpened())
    {
    cerr << " Error ! camera could not be opened\n";
    cout << " check if the camera is connected to the Raspberry Pi board" << endl;
    cap.release();
    imageViewerActive =0;
    return CAMERA_COULD_NOT_BE_OPENED;
    }
cout << "Start grabbing the video" << endl
     << "Press ESC key to terminate the software"<< endl;
     namedWindow("Trebax Vision Engineering: Image viewer",WINDOW_AUTOSIZE);
while(imageViewerActive)
    {
    //cap.read(frame);
    cap >> frame;
    if(frame.empty()){
        cerr << "ERROR! blank frame grabbed \n";
        break;
        }

    imshow("Trebax Vision Engineering: Image viewer", frame);
    if(waitKey(5) == 27) break;
    }
 cap.release();
 destroyWindow("Trebax Vision Engineering: Image viewer");
 imageViewerActive = 0;
 return VIEWERSUCCESS;
}

int CVid::SearchForNumberCameras(void)
{
    int numbCam=0 , n;
    for(n = 0; n <10; n++)
    {
        VideoCapture cap(n);
        if(cap.isOpened())numbCam++;
        else n = 0x10;
    }
    return numbCam;
}
