// rev 3-0.0

#include <iostream>
#include <gtkmm-3.0/gtkmm.h>
//#include <gtk/gtk.h>

#include "I2C_interface.h"
#include "SupportFunctions.h"

#include <pthread.h>

using namespace std;

//void LoadStartValues(void);
void CreateThread(void);
void *myThreadProc(void *vargp);
void stopMyThreadProc(void);

pthread_t tid;


// Custom structure that holds pointers to widgets and user variables
struct Widgets {
    // Add pointers to widgets below
	Gtk::Window *pWin_Main;

	Gtk::Button *pbtn_zoom_in;                                // zoom controls
	Gtk::Button *pbtn_zoom_out;
	Gtk::Button *pbtn_zoom_stop;
	Gtk::Button *pbtn_go_to_pos;
	Gtk::Button *pbtn_snapshot;
    Gtk::ComboBoxText *pcomboboxtxt_zoom_speed;
	Gtk::ComboBoxText *pcomboboxtxt_zoom_mode;
	Gtk::ComboBoxText *pcomboboxtxt_zoom_mode_popdown;
    Gtk::Scrollbar *pscrb_zoom_pos;
	Gtk::Label *plbl_zoom_pos_value;

	Gtk::Button *pbtn_focus_tele;                        // focus controls
	Gtk::Button *pbtn_focus_wide;
	Gtk::Button *pbtn_focus_stop;
	Gtk::ComboBoxText *pcomboboxtxt_focus_speed;
	Gtk::ComboBoxText *pcomboboxtxt_focus_mode;

	Gtk::Button *pbtn_wb_p2s;                            // white balance control
	Gtk::ComboBoxText *pcomboboxtxt_awb_mode;
	Gtk::Label *plbl_man_red_gain;
	Gtk::Scrollbar *pscrb_man_red_gain;
	Gtk::Label *plbl_man_blue_gain;
	Gtk::Scrollbar *pscrb_man_blue_gain;
    Gtk::CheckButton *pchbtn_man_gain;                                     // AEX control
    Gtk::Label *plbl_man_gain;
    Gtk::Label *plbl_shutter;
    Gtk::Scrollbar *pscrb_man_gain;
    Gtk::ComboBoxText *pcomboboxtxt_shutter_mode;


    //Gtk::CheckButton *pchbtn_man_iris;                                     // manual Iris control
    Gtk::Label *plbl_man_iris;
    Gtk::Scrollbar *pscrb_man_iris;

    Gtk::CheckButton *pchbtn_wdr_mode;
    Gtk::Label *plbl_wdr_mode;
    Gtk::Scrollbar *pscrb_wdr_level;
    Gtk::CheckButton *pchbtn_dnr_mode;
    Gtk::Label *plbl_dnr_mode;
    Gtk::Scrollbar *pscrb_dnr_level;

    Gtk::ComboBoxText *pcomboboxtxt_is_level;
    Gtk::ComboBoxText *pcomboboxtxt_is_filter;

    Gtk::ComboBoxText *pcomboboxtxt_aperature_gain;
    Gtk::CheckButton *pchbtn_mirror_mode;
    Gtk::CheckButton *pchbtn_flip_mode;
    Gtk::CheckButton *pchbtn_freeze;
    Gtk::CheckButton *pchbtn_image_stabilizer_on;
    Gtk::ComboBoxText *pcomboboxtxt_video_mode;

   // Gtk::Button *pbtn_start_viewer;
  //  Gtk::Button *pbtn_stop_viewer;



   Widgets(Glib::RefPtr<Gtk::Builder> builder) {
	   builder->get_widget("window_main", pWin_Main);
	   builder->get_widget("btn_zoom_in", pbtn_zoom_in);
	   builder->get_widget("btn_zoom_out", pbtn_zoom_out);
	   builder->get_widget("btn_zoom_stop", pbtn_zoom_stop);
	   builder->get_widget("btn_go_to_pos", pbtn_go_to_pos);
	   builder->get_widget("scrb_zoom_pos", pscrb_zoom_pos);
	   builder->get_widget("comboboxtxt_zoom_mode", pcomboboxtxt_zoom_mode);
	   builder->get_widget("comboboxtxt_zoom_speed",pcomboboxtxt_zoom_speed);
	   builder->get_widget("lbl_zoom_pos_value", plbl_zoom_pos_value);
	   builder->get_widget("btn_focus_tele", pbtn_focus_tele);
	   builder->get_widget("btn_focus_wide", pbtn_focus_wide);
	   builder->get_widget("btn_focus_stop", pbtn_focus_stop);
	   builder->get_widget("comboboxtxt_focus_speed", pcomboboxtxt_focus_speed);
	   builder->get_widget("comboboxtxt_focus_mode", pcomboboxtxt_focus_mode);
	   builder->get_widget("btn_wb_p2s", pbtn_wb_p2s);
	   builder->get_widget("comboboxtxt_awb_mode", pcomboboxtxt_awb_mode);
	   builder->get_widget("lbl_man_red_gain", plbl_man_red_gain);
	   builder->get_widget("scrb_man_red_gain",pscrb_man_red_gain);
	   builder->get_widget("lbl_man_blue_gain", plbl_man_blue_gain);
	   builder->get_widget("scrb_man_blue_gain", pscrb_man_blue_gain);
	   builder->get_widget("chbtn_man_gain", pchbtn_man_gain);
	   builder->get_widget("lbl_man_gain", plbl_man_gain);
	   builder->get_widget("lbl_shutter", plbl_shutter);
	   builder->get_widget("scrb_man_gain", pscrb_man_gain);
	   builder->get_widget("comboboxtxt_shutter_mode",pcomboboxtxt_shutter_mode);
	   //builder->get_widget("chbtn_man_iris", pchbtn_man_iris);
	   builder->get_widget("lbl_man_iris", plbl_man_iris);
	   builder->get_widget("scrb_man_iris", pscrb_man_iris);
	   builder->get_widget("chbtn_wdr_mode", pchbtn_wdr_mode);
	   builder->get_widget("lbl_wdr_mode", plbl_wdr_mode);
	   builder->get_widget("scrb_wdr_level", pscrb_wdr_level);
	   builder->get_widget("chbtn_dnr_mode", pchbtn_dnr_mode);
	   builder->get_widget("lbl_dnr_mode", plbl_dnr_mode);
	   builder->get_widget("scrb_dnr_level", pscrb_dnr_level);
	   builder->get_widget("comboboxtxt_is_level", pcomboboxtxt_is_level);
	   builder->get_widget("comboboxtxt_is_filter", pcomboboxtxt_is_filter);
	   builder->get_widget("comboboxtxt_aperature_gain", pcomboboxtxt_aperature_gain);
	   builder->get_widget("chbtn_mirror_mode", pchbtn_mirror_mode);
	   builder->get_widget("chbtn_flip_mode", pchbtn_flip_mode);
	   builder->get_widget("chbtn_freeze", pchbtn_freeze);
	   builder->get_widget("chbtn_image_stabilizer_on", pchbtn_image_stabilizer_on);
	   builder->get_widget("comboboxtxt_video_mode", pcomboboxtxt_video_mode);
       builder->get_widget("btn_snapshot", pbtn_snapshot);
   }

   void on_btn_zoom_in_clicked();
   void on_btn_zoom_out_clicked();
   void on_btn_zoom_stop_clicked();
   void on_btn_go_to_pos_clicked();
   void on_comboboxtxt_zoom_speed_changed();
   void on_comboboxtxt_zoom_mode_changed();

   void on_btn_focus_tele_clicked();
   void on_btn_focus_wide_clicked();
   void on_btn_focus_stop_clicked();
   void on_comboboxtxt_focus_speed_changed();
   void on_comboboxtxt_focus_mode_changed();
   void on_btn_wb_p2s_clicked();
   void on_chbtn_man_gain_toggled();
   //void on_chbtn_man_iris_toggled();
   void on_chbtn_wdr_mode_toggled();
   void on_chbtn_dnr_mode_toggled();
   void on_chbtn_mirror_mode_toggled();
   void on_chbtn_flip_mode_toggled();
   void on_chbtn_freeze_toggled();
   void on_chbtn_image_stabilizer_on_toggled();
   void on_comboboxtxt_awb_mode_changed();
   void on_comboboxtxt_shutter_mode_changed();
   void on_comboboxtxt_is_level_changed();
   void on_comboboxtxt_is_filter_changed();
   void on_comboboxtxt_aperature_gain_changed();
   void on_comboboxtxt_video_mode_changed();
   void on_scrb_zoom_pos_value_changed();
   void on_scrb_man_red_gain_value_changed();
   void on_scrb_man_blue_gain_value_changed();
   void on_scrb_man_gain_value_changed();
   void on_scrb_man_iris_value_changed();
   void on_scrb_wdr_level_value_changed();
   void on_scrb_dnr_level_value_changed();
   void on_btn_snapshot_clicked();

   void Set_Gui_controls_ZoomMode();
   void Set_Gui_controls_FocusMode();
   void Set_Gui_controls_AWB();
   void Set_Gui_controls_AEX();
   void Set_Gui_SpecLevels();
   void Set_Gui_IS_control();

   int run() {
	   // connect a handler to btn_test clicked signal
	   pbtn_zoom_in->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_zoom_in_clicked));                                // zoom controls
	   pbtn_zoom_out->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_zoom_out_clicked));
	   pbtn_zoom_stop->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_zoom_stop_clicked));
	   pbtn_go_to_pos->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_go_to_pos_clicked));
	   pbtn_snapshot->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_snapshot_clicked));
	   pcomboboxtxt_zoom_speed->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_zoom_speed_changed));
	   pcomboboxtxt_zoom_mode->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_zoom_mode_changed));
	   pscrb_zoom_pos->signal_value_changed().connect(sigc::mem_fun(this, &Widgets::on_scrb_zoom_pos_value_changed));

	   pbtn_focus_tele->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_focus_tele_clicked));                            // focus controls
	   pbtn_focus_wide->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_focus_wide_clicked));
	   pbtn_focus_stop->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_focus_stop_clicked));
	   pcomboboxtxt_focus_speed->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_focus_speed_changed));
	   pcomboboxtxt_focus_mode->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_focus_mode_changed));

	   pbtn_wb_p2s->signal_clicked().connect(sigc::mem_fun(this, &Widgets::on_btn_wb_p2s_clicked));                            // white balance control
	   pcomboboxtxt_awb_mode->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_awb_mode_changed));
	   pscrb_man_red_gain->signal_value_changed().connect(sigc::mem_fun(this, &Widgets::on_scrb_man_red_gain_value_changed));
	   pscrb_man_blue_gain->signal_value_changed().connect(sigc::mem_fun(this, &Widgets::on_scrb_man_blue_gain_value_changed));
	   pchbtn_man_gain->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_man_gain_toggled));                                      // AEX control
	   pscrb_man_gain->signal_value_changed().connect(sigc::mem_fun(this, &Widgets::on_scrb_man_gain_value_changed));
	   pcomboboxtxt_shutter_mode->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_shutter_mode_changed));


       //pchbtn_man_iris->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_man_iris_toggled));     // manual Iris control
	   pscrb_man_iris->signal_value_changed().connect(sigc::mem_fun(this, &Widgets::on_scrb_man_iris_value_changed));

	   pchbtn_wdr_mode->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_wdr_mode_toggled));
	   pscrb_wdr_level->signal_value_changed().connect(sigc::mem_fun(this, &Widgets::on_scrb_wdr_level_value_changed));
	   pchbtn_dnr_mode->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_dnr_mode_toggled));
	   pscrb_dnr_level->signal_value_changed().connect(sigc::mem_fun(this, &Widgets::on_scrb_dnr_level_value_changed));

	   pcomboboxtxt_is_level->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_is_level_changed));
	   pcomboboxtxt_is_filter->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_is_filter_changed));

	   pcomboboxtxt_aperature_gain->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_aperature_gain_changed));
	   pchbtn_mirror_mode->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_mirror_mode_toggled));
	   pchbtn_flip_mode->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_flip_mode_toggled));
	   pchbtn_freeze->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_freeze_toggled));
	   pchbtn_image_stabilizer_on->signal_toggled().connect(sigc::mem_fun(this, &Widgets::on_chbtn_image_stabilizer_on_toggled));
	   pcomboboxtxt_video_mode->signal_changed().connect(sigc::mem_fun(this, &Widgets::on_comboboxtxt_video_mode_changed));



	   // exit when *pWin_Main closes
	   Gtk::Main::run(*pWin_Main);
	   return EXIT_SUCCESS;
   }

} ;

extern "C" G_MODULE_EXPORT void on_window_main_destroy()
{
    gtk_main_quit();
    pthread_exit(NULL);
    cout << "press escape to stop viewer";
}

void LoadStartValues(Widgets *appwdgts);

uint16_t   zoomPos;
uint8_t zoomSpeed, zoomMode, focusMode, focusSpeed;
uint8_t manualgain, manualShutter, manualIris;
uint8_t wdrLevel, dnrLevel, stableizerLevel, stableizerFilter;
uint8_t manRedGain, manBlueGain;
uint8_t aexModus, awbModus, shutterMode;
uint8_t aperatureGain, videoMode;



int main(int argc, char *argv[])
{
    Gtk::Main kit(argc, argv);
    cout <<" Hi Raspberry Pi!! Loading camera settings\n"<<endl;
    CreateThread();
    Widgets allTheWidgets(Gtk::Builder::create_from_file("gladeGui/window_main.glade"));  //
    LoadStartValues(&allTheWidgets);

   return allTheWidgets.run();

    return 0;

}


void LoadStartValues(Widgets *appwdgts)
{
uint8_t errorMessage = SUCCESS;
uint8_t dataArray[NUMBER_OF_DEFAULT_VAL] = {0};
LoadDefaultValuesAtStartUp(dataArray);
zoomMode =0;
zoomPos = dataArray[0];
zoomSpeed = dataArray[1];
focusMode = 0;
focusSpeed = dataArray[2];
manualgain = dataArray[3];
manualShutter = dataArray[4];
manualIris = dataArray[5];
wdrLevel = dataArray[6];
dnrLevel = dataArray[7];
awbModus = 0;
manRedGain = dataArray[8];
manBlueGain = dataArray[9];
stableizerLevel = dataArray[10];
stableizerFilter  = dataArray[11];
aperatureGain = dataArray[12];
videoMode = dataArray[13];
aexModus = 0x30;                    // default auto mode


if(errorMessage == SUCCESS)printf(" Connecting to camera was succesfull\n");
else
    {
    printf(" ERROR: check camera and connection\n");
    return;
    }
appwdgts->Set_Gui_controls_ZoomMode();
appwdgts->Set_Gui_controls_FocusMode();
appwdgts->Set_Gui_controls_AWB();
appwdgts->Set_Gui_controls_AEX();
appwdgts->Widgets::Set_Gui_SpecLevels();
appwdgts->Widgets::Set_Gui_IS_control();

}
//************************************************************************************************************************
//  call functions
//************************************************************************************************************************

//--------------------------        Zoom buttons        ------------------------------------------------------------------
void Widgets::on_btn_zoom_in_clicked()
{
    uint8_t *pZoomdata = 0;
    uint8_t errorMessage = I2C_Zoom_Fuction( I2C_ZOOM_IN, zoomSpeed, pZoomdata);
    if(errorMessage != SUCCESS)
    {
        g_print(" An error occured in Zoom-In call function %x: \n", errorMessage);
    }
}

void Widgets::on_btn_zoom_out_clicked()
{
    uint8_t *pZoomdata = 0;
    uint8_t errorMessage = I2C_Zoom_Fuction( I2C_ZOOM_OUT, zoomSpeed, pZoomdata);
    if(errorMessage != SUCCESS)
    {
        g_print(" An error occured in Zoom-Out call function %x: \n", errorMessage);
    }
}

void Widgets::on_btn_zoom_stop_clicked()
{
    uint8_t *pZoomdata = 0;
    uint8_t errorMessage = I2C_Zoom_Fuction( I2C_ZOOM_STOP, zoomSpeed, pZoomdata);
    if(errorMessage != SUCCESS)
    {
        g_print(" An error occured in Zoom-Stop call function %x: \n", errorMessage);
    }
}


//----------------------------   ComboBox controls   ---------------------------------------------------------------------

void Widgets::on_comboboxtxt_zoom_speed_changed()
{
    gint item_number = 0;
    item_number = pcomboboxtxt_zoom_speed->get_active_row_number();
    zoomSpeed = (uint8_t) item_number+1;

}

void Widgets::on_comboboxtxt_zoom_mode_changed()
{
    gint item_number = 0;
    item_number = pcomboboxtxt_zoom_mode->get_active_row_number();
    zoomMode = (uint8_t) item_number;
    Set_Gui_controls_ZoomMode();


}

void Widgets::Set_Gui_controls_ZoomMode()
{
    switch (zoomMode){
        case 0:  pscrb_zoom_pos->set_sensitive(false); pbtn_zoom_in->set_sensitive(true); pbtn_zoom_out->set_sensitive(true); pbtn_zoom_stop->set_sensitive(true);
                 pcomboboxtxt_zoom_speed->set_sensitive(true); pbtn_go_to_pos->set_sensitive(false); break;
        case 1:  pscrb_zoom_pos->set_sensitive(false); pbtn_zoom_in->set_sensitive(true); pbtn_zoom_out->set_sensitive(true); pbtn_zoom_stop->set_sensitive(true);
                 pcomboboxtxt_zoom_speed->set_sensitive(true); pbtn_go_to_pos->set_sensitive(false); break;
        case 2:  pscrb_zoom_pos->set_sensitive(true); pbtn_zoom_in->set_sensitive(false); pbtn_zoom_out->set_sensitive(false); pbtn_zoom_stop->set_sensitive(false);
                 pcomboboxtxt_zoom_speed->set_sensitive(false);  pbtn_go_to_pos->set_sensitive(true);  break;
    }
    pbtn_snapshot->set_sensitive(false);  //disable snapshot since function does not work (yet)
}

void Widgets::on_scrb_zoom_pos_value_changed()
{
    uint8_t errorMessage = SUCCESS;
    gdouble scbValue;
    unsigned char zoomposition[2];
    gchar zoom_pos_str[5] = {0}; // buffer for string
    int sliderpos = (int)pscrb_zoom_pos->get_value();
    int sliderPosRounded = sliderpos / 51;
    if(sliderPosRounded>320) sliderPosRounded = 320;
    else if(sliderPosRounded == 0) sliderPosRounded = 1;
    ConvertUint2string((unsigned int) sliderPosRounded, zoom_pos_str);
    plbl_zoom_pos_value->set_text(zoom_pos_str);
    zoomPos = (uint16_t)(sliderpos & 0x3fff);
    zoomposition[0] = zoomPos/256;
    zoomposition[1] = zoomPos%256;
    errorMessage = I2C_Zoom_Fuction( I2C_ZOOM_POSITION_H, zoomSpeed, zoomposition);
    errorMessage = I2C_Zoom_Fuction( I2C_ZOOM_POSITION_L, zoomSpeed, (zoomposition+1));
}

void Widgets::on_btn_go_to_pos_clicked()
{
    unsigned char dummy[1] = {0};
     if(zoomMode == 2) I2C_Zoom_Fuction( I2C_ZOOM_MODE_ZOOM_2_POS , zoomSpeed, dummy);
}
//--------------------------        Focus buttons        ------------------------------------------------------------------

void Widgets::on_btn_focus_tele_clicked()
{
    uint8_t *pfocusdata = 0;
    uint8_t errorMessage = I2C_Focus_Fuction( I2C_FOCUS_TELE, focusSpeed, pfocusdata);
    if(errorMessage != SUCCESS)
    {
        g_print(" An error occured in Focus-In call function %x: \n", errorMessage);
    }
}

void Widgets::on_btn_focus_wide_clicked()
{
    uint8_t *pfocusdata = 0;
    uint8_t errorMessage = I2C_Focus_Fuction( I2C_FOCUS_WIDE, focusSpeed, pfocusdata);
    if(errorMessage != SUCCESS)
    {
        g_print(" An error occured in Focus-Out call function %x: \n", errorMessage);
    }
}

void Widgets::on_btn_focus_stop_clicked()
{
    uint8_t *pfocusdata = 0;
    uint8_t errorMessage = I2C_Focus_Fuction( I2C_FOCUS_STOP, focusSpeed, pfocusdata);
    if(errorMessage != SUCCESS)
    {
        g_print(" An error occured in Focus-Stop call function %x: \n", errorMessage);
    }
}

void Widgets::on_comboboxtxt_focus_speed_changed()
{
    gint item_number = 0;
    item_number = pcomboboxtxt_focus_speed->get_active_row_number();
    focusSpeed = (uint8_t) item_number+1;
}

void Widgets::on_comboboxtxt_focus_mode_changed()
{
uint8_t errorMessage = SUCCESS;
    uint8_t *pfocusdata = 0;
    gint item_number = 0;
    item_number = pcomboboxtxt_focus_mode->get_active_row_number();
    focusMode = (uint8_t) item_number;
    Set_Gui_controls_FocusMode();
    switch(focusMode){
        case 0: I2C_Focus_Fuction( I2C_FOCUS_AUTO, focusSpeed, pfocusdata); break;
        case 1: I2C_Focus_Fuction( I2C_FOCUS_MAN, focusSpeed, pfocusdata); break;
        case 2: I2C_Focus_Fuction( I2C_FOCUS_ON_ZOOM, focusSpeed, pfocusdata);break;
    }
    if(errorMessage != SUCCESS)g_print(" An error occured in Focus-Mode call function %x: \n", errorMessage);
}

void Widgets::Set_Gui_controls_FocusMode()
{
    switch (focusMode){
        case 0:  pbtn_focus_tele->set_sensitive(false); pbtn_focus_wide->set_sensitive(false);
                 pbtn_focus_stop->set_sensitive(false); pcomboboxtxt_focus_speed->set_sensitive(false);  break;
        case 1:  pbtn_focus_tele->set_sensitive(true); pbtn_focus_wide->set_sensitive(true);
                 pbtn_focus_stop->set_sensitive(true); pcomboboxtxt_focus_speed->set_sensitive(true);  break;
        case 2:  pbtn_focus_tele->set_sensitive(false); pbtn_focus_wide->set_sensitive(false);
                 pbtn_focus_stop->set_sensitive(false); pcomboboxtxt_focus_speed->set_sensitive(false);  break;
    }
}


//--------------------------        AWB functions        ------------------------------------------------------------------
void Widgets::on_comboboxtxt_awb_mode_changed()
{
    gint item_number = 0;
    uint8_t awbdata[2] ;
    awbdata[0] = manRedGain;
    awbdata[1] = manBlueGain;
    item_number = pcomboboxtxt_awb_mode->get_active_row_number();
    awbModus = (uint8_t) item_number;
    Set_Gui_controls_AWB();
    switch (awbModus){
        case 0:  I2C_AWB_Fuction( I2C_AWB_AUTO ,   awbdata); break;
        case 1:  awbdata[0] = 0x0; I2C_AWB_Fuction( I2C_AWB_P2S ,   awbdata); break;
        case 2:  I2C_AWB_Fuction( AWM_MANUAL_MODE , awbdata);break;
        }
}

void Widgets::Set_Gui_controls_AWB()
{
    switch (awbModus){
        case 0:  pbtn_wb_p2s->set_sensitive(false); pscrb_man_red_gain->set_sensitive(false); pscrb_man_blue_gain->set_sensitive(false);
                 plbl_man_red_gain->set_sensitive(false);  plbl_man_blue_gain->set_sensitive(false);break;
        case 1:  pbtn_wb_p2s->set_sensitive(true); pscrb_man_red_gain->set_sensitive(false);pscrb_man_blue_gain->set_sensitive(false);
                 plbl_man_red_gain->set_sensitive(false);  plbl_man_blue_gain->set_sensitive(false);break;
        case 2:  pbtn_wb_p2s->set_sensitive(false); pscrb_man_red_gain->set_sensitive(true);pscrb_man_blue_gain->set_sensitive(true);
                 plbl_man_red_gain->set_sensitive(true);  plbl_man_blue_gain->set_sensitive(true);break;
                 }
}

void Widgets::on_btn_wb_p2s_clicked()
{
    uint8_t awbdata[2] = {0};
    awbdata[0] = 0xa5;
    uint8_t errorMessage = I2C_AWB_Fuction( I2C_PSW_ACT, awbdata);
    if(errorMessage != SUCCESS)
    {
        g_print(" An error occured in P2W call function %x: \n", errorMessage);
    }
}


void Widgets::on_scrb_man_red_gain_value_changed()
{
    uint8_t manAwbGain[1];
    gchar rgain_pos_str[5] = {0}; // buffer for string
    manAwbGain[0] = (int)pscrb_man_red_gain->get_value();
    if(manAwbGain[0]>20) manAwbGain[0] = 20;
    manRedGain = manAwbGain[0];
    ConvertUint2string(manRedGain, rgain_pos_str);
    plbl_man_red_gain->set_text(rgain_pos_str);
    if(I2C_AWB_Fuction(I2C_WB_RGAIN , manAwbGain) != SUCCESS) g_print(" An error occured in setting AWB man R gain");
}

void Widgets::on_scrb_man_blue_gain_value_changed()
{
    uint8_t manAwbGain[1];
    gchar bgain_pos_str[5] = {0}; // buffer for string
    manAwbGain[0] = (int)pscrb_man_blue_gain->get_value();
    if(manAwbGain[0] > 20) manAwbGain[0] = 20;
    manBlueGain = manAwbGain[0];
    ConvertUint2string(manBlueGain, bgain_pos_str);
    plbl_man_blue_gain->set_text(bgain_pos_str);
    if(I2C_AWB_Fuction(I2C_WB_BGAIN , manAwbGain) != SUCCESS) g_print(" An error occured in setting AWB man R gain");
}

//************************************************************************************************************************
// AEX
//************************************************************************************************************************
void Widgets::on_chbtn_man_gain_toggled()
{
	uint8_t errorMessage = SUCCESS;
	uint8_t pMangain[1] = {0};
	bool isBTNchecked =pchbtn_man_gain->get_active();
	if (isBTNchecked) pMangain[0] =1 ;       // set manual gain flag
	errorMessage = I2C_AEX_Fuction( 0x30, pMangain);
    if(errorMessage != SUCCESS)g_print(" An error occured in AEX I2C part");
    Set_Gui_controls_AEX();
}

void Widgets::on_scrb_man_gain_value_changed()
{
    gchar gain_pos_str[5] = {0}; // buffer for string
    uint8_t pMangain[1];
    manualgain = (uint8_t)pscrb_man_gain->get_value();
    ConvertUint2string((unsigned int) manualgain, gain_pos_str);
    pMangain[0] = manualgain;
    plbl_man_gain->set_text(gain_pos_str);
    I2C_AEX_Fuction( 0x31, pMangain);
}

/*
void Widgets::on_chbtn_man_iris_toggled()
{
	//g_print("%s\n", gtk_widget_get_name(GTK_WIDGET(togglebutton)));
	uint8_t errorMessage = SUCCESS;
	uint8_t pManiris[1];
	pManiris[0]= manualIris ;
	if (pchbtn_man_iris->get_active()) aexModus |= AEX_IRIS_MANUAL ;       // set manual gain flag
	else aexModus &= ~AEX_IRIS_MANUAL ;                                                  // clear manual gain
	if(aexModus == I2C_AEX_MODE)errorMessage = I2C_AEX_Fuction( aexModus, pManiris);
	else{
        if((aexModus & 0x34) == 0x34) errorMessage = I2C_AEX_Fuction( 0x34, pManiris);
	}
    if(errorMessage != SUCCESS)g_print(" An error occured in AEX I2C part");
	Set_Gui_controls_AEX();
}
*/

void Widgets::on_scrb_man_iris_value_changed()
{
    uint8_t pManiris[1], displayValue;
    gchar iris_pos_str[5] = {0}; // buffer for string
    manualIris = (uint8_t)pscrb_man_iris->get_value();
    if(manualIris >0x0d)manualIris = 0x0d;
    if(manualIris>0) displayValue = manualIris + 4;
    else displayValue = manualIris;
    ConvertUint2string( displayValue, iris_pos_str);
    pManiris[0] = manualIris;
    plbl_man_iris->set_text(iris_pos_str);
    I2C_AEX_Fuction( 0x34, pManiris);
}


void Widgets::on_comboboxtxt_shutter_mode_changed()
{
    gint item_number = 0;
    uint8_t shutterdata[1] ;
    item_number = pcomboboxtxt_shutter_mode->get_active_row_number();
    manualShutter  = (uint8_t) item_number;
    if(manualShutter == 1) shutterdata[0] = FLICKER_LESS_SHUTTER;
    else shutterdata[0] = manualShutter;
    I2C_AEX_Fuction( 0x32, shutterdata);
}

void Widgets::Set_Gui_controls_AEX()
{
    if(pchbtn_man_gain->get_active() == false)
    {
                pscrb_man_gain->set_sensitive(false); pscrb_man_iris->set_sensitive(false); plbl_man_gain->set_sensitive(false);
                plbl_man_iris->set_sensitive(false); pcomboboxtxt_shutter_mode->set_sensitive(false); plbl_shutter->set_sensitive(false);
     }
    else
        {
                pscrb_man_gain->set_sensitive(true); pscrb_man_iris->set_sensitive(true); plbl_man_gain->set_sensitive(true);
                plbl_man_iris->set_sensitive(true); pcomboboxtxt_shutter_mode->set_sensitive(true); plbl_shutter->set_sensitive(true);
        }
}

//**********************************************************************************************************************************************************
void Widgets::on_chbtn_wdr_mode_toggled()
{
	uint8_t errorMessage = SUCCESS;
	uint8_t mode[1];
	if (pchbtn_wdr_mode->get_active()) mode[0] = WDR_MODE_ON;      // set manual gain flag
	else mode[0] = WDR_MODE_OFF;                                                // clear manual gain
	errorMessage = I2C_AEX_Fuction( 0x38, mode);
	Set_Gui_SpecLevels();
}

void Widgets::on_scrb_wdr_level_value_changed()
{
    uint8_t pWDRlevel[1];
    gchar wdrLevel_str[5] = {0}; // buffer for string
    wdrLevel = (uint8_t)pscrb_wdr_level->get_value();
    ConvertUint2string( wdrLevel, wdrLevel_str);
    pWDRlevel[0] = wdrLevel;
    plbl_wdr_mode->set_text(wdrLevel_str);
    I2C_AEX_Fuction( 0x38, pWDRlevel);
}

void Widgets::on_chbtn_dnr_mode_toggled()
{
	uint8_t errorMessage = SUCCESS;
	uint8_t mode[1];
	if (pchbtn_dnr_mode->get_active()) mode[0] = DNR_MODE_ON;               // set manual gain flag
	else mode[0] = DNR_MODE_OFF;                                                // clear manual gain
	errorMessage = I2C_AEX_Fuction( 0x39, mode);
	Set_Gui_SpecLevels();
}

void Widgets::on_scrb_dnr_level_value_changed()
{
    uint8_t pDNRlevel[1];
    gchar dnrLevel_str[5] = {0}; // buffer for string
    dnrLevel = (uint8_t)pscrb_dnr_level->get_value();
    ConvertUint2string( dnrLevel, dnrLevel_str);
    pDNRlevel[0] = dnrLevel;
    plbl_dnr_mode->set_text(dnrLevel_str);
    I2C_AEX_Fuction( 0x39, pDNRlevel);
}

void Widgets::Set_Gui_SpecLevels()
{
    if(pchbtn_dnr_mode->get_active()){pscrb_dnr_level->set_sensitive(true);plbl_dnr_mode->set_sensitive(true);}
    else { pscrb_dnr_level->set_sensitive(false);plbl_dnr_mode->set_sensitive(false);}
   if(pchbtn_wdr_mode->get_active()) { pscrb_wdr_level->set_sensitive(true); plbl_wdr_mode->set_sensitive(true);}
    else { pscrb_wdr_level->set_sensitive(false);plbl_wdr_mode->set_sensitive(false);}
}

void Widgets::on_comboboxtxt_video_mode_changed()       // day-nigth function
{
    gint item_number = 0;
    uint8_t pData[1];
    item_number = pcomboboxtxt_video_mode->get_active_row_number();
    videoMode = (uint8_t) (item_number & 0x03);
    pData[0] = videoMode;
    I2C_AEX_Fuction( I2C_DAY_NIGTH_MODE, pData);
}
//*****************************************************************************************************************************************************************************

void Widgets::on_chbtn_mirror_mode_toggled()
{
    uint8_t errorMessage = SUCCESS;
    uint8_t pData[1];
    if (pchbtn_mirror_mode->get_active()) pData[0] = 1;      // set manual gain flag
	else pData[0] = 0;
    I2C_Feature_Fuction( I2C_MIRROR_MODE, pData);
}

void Widgets::on_chbtn_flip_mode_toggled()
{
    uint8_t errorMessage = SUCCESS;
    uint8_t pData[1];
    if (pchbtn_flip_mode->get_active()) pData[0] = 1;      // set manual gain flag
	else pData[0] = 0;
    I2C_Feature_Fuction( I2C_FLIP_MODE, pData);
}

void Widgets::on_chbtn_freeze_toggled()
{
    uint8_t errorMessage = SUCCESS;
    uint8_t pData[1];
    if (pchbtn_freeze->get_active()) pData[0] = 1;      // set manual gain flag
	else pData[0] = 0;
    I2C_Feature_Fuction( I2C_FREEZE_MODE, pData);
}

void Widgets::on_chbtn_image_stabilizer_on_toggled()
{
    uint8_t errorMessage = SUCCESS;
    uint8_t pData[2], help;
    if (pchbtn_image_stabilizer_on->get_active())
    {
        pData[0] = 0x80;      // set manual gain flag
    }
	else pData[0] = 0;
    errorMessage = I2C_Feature_Fuction( I2C_IMAGE_STABALIZER, pData);
    if(errorMessage != SUCCESS)g_print(" An error occured in AEX I2C Image Stabilizer");
    Set_Gui_IS_control();
}

void Widgets::on_comboboxtxt_is_level_changed()
{
    uint8_t errorMessage = SUCCESS;
    gint item_number = 0;
    uint8_t pData[1], help;
    item_number = pcomboboxtxt_is_level->get_active_row_number();
    stableizerLevel = (uint8_t) item_number;

        pData[0] = stableizerLevel;
        errorMessage = I2C_Feature_Fuction( I2C_IMAGE_STABALIZER_LEVEL, pData);
        if(errorMessage != SUCCESS)g_print(" An error occured in AEX I2C Image Stabilizer");

}

void Widgets::on_comboboxtxt_is_filter_changed()
{
    uint8_t errorMessage = SUCCESS;
    gint item_number = 0;
    uint8_t pData[1], help;
    item_number = pcomboboxtxt_is_filter->get_active_row_number();
    stableizerFilter = (uint8_t) item_number;
    pData[0]  = (stableizerFilter & 0x03);
    errorMessage = I2C_Feature_Fuction( I2C_IMAGE_STABALIZER_Range, pData);
    if(errorMessage != SUCCESS)g_print(" An error occured in AEX I2C Image Stabilizer");
}

void Widgets::Set_Gui_IS_control()
{
    if (pchbtn_image_stabilizer_on->get_active())
    {
        pcomboboxtxt_is_filter->set_sensitive(true);
        pcomboboxtxt_is_level->set_sensitive(true);
    }
    else
    {
        pcomboboxtxt_is_filter->set_sensitive(false);
        pcomboboxtxt_is_level->set_sensitive(false);
    }
}

void Widgets::on_comboboxtxt_aperature_gain_changed()
{
    uint8_t errorMessage = SUCCESS;
    gint item_number = 0;
    uint8_t pData[1];
    item_number = pcomboboxtxt_aperature_gain->get_active_row_number();
    aperatureGain = (uint8_t) item_number;
    pData[0] = aperatureGain;
    errorMessage = I2C_AEX_Fuction( APERATURE_GAIN, pData);
    if(errorMessage != SUCCESS)g_print(" An error occured in AEX I2C Image Stabilizer");
}

// problem is that viewer must be closed. Therefor viewer part of software must be modified so that it can accept input the close it.
// for this reasomn the snapshot function is not included.
void Widgets::on_btn_snapshot_clicked()
{
    string path2exe = "snapshot/SnapShot";
    stopMyThreadProc();
    system(path2exe.c_str());
    CreateThread(); // restart viewer
}


//*********************************************************************************************************************************************************
// background thread
//*********************************************************************************************************************************************************
void CreateThread(void)
{
    static char runOnly1time =0;
    if(!runOnly1time) pthread_create(&tid, NULL,myThreadProc, NULL );
    else runOnly1time = 2;
 //  tid = pthread_self();
    return;
}


void *myThreadProc(void *vargp)
{
    string path2exe = "viewer/IndCamT1";
  //  string path2exe = "/home/pi/SoftWare/IndCamera/TestCamera1/IndCamT1probeersel2/bin/Release/IndCamT1";
    system(path2exe.c_str());
}

void stopMyThreadProc(void)
{

}



